/*
    Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

/* configure all options BEFORE including system stuff. */
#include    "config.h"
#include    "mud.h"
#include    "match.h"
#include    "vars.h"

/*
TinyMUD-like "whisper"
*/

/* ARGSUSED */
int cmd_whisper (int argc, char *argv[], char *who, char *aswho)
{
  char ob[MAXOID];
  char *xx;
  int fnd = 0;

  if (matchplayers (who, argv[1], ut_loc (who), MTCH_UNIQ | MTCH_MEOK, ob))
    return (UERR_NOMATCH);

  io_rstnxtwho ();
  while ((xx = io_nxtwho ((long) 0)) != (char *) 0) {
    if (!strcmp (xx, ob)) {
      fnd++;
      break;
    }
  }

  if (!fnd) {
    say (who, ut_name (ob), " isn't connected.\n", (char *) 0);
    return (UERR_BADOID);
  }
  say (ob, ut_name (who), " whispers, \"", argv[2], "\".\n", (char *) 0);
  say (who, "You whisper, \"", argv[2], "\" to ", ut_name (ob), ".\n",
    (char *) 0);
  return (UERR_NONE);
}
