/*
        Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

/* configure all options BEFORE including system stuff. */
#include        "config.h"

#ifdef  DB_DBMFILE

#include        "mud.h"

/*
binding to the command level interface. this just parses and calls
lower level configuration code in the db layer.
*/



/* ARGSUSED */
int cmd__dddbconfig (int argc, char *argv[], char *who, char *aswho)
{
  /* configure database hash size */
  if (!strcmp (argv[1], "bsiz")) {
    int tmpx;

    if (dddb_initted ()) {
      log_printf ("database is already active.\n", (char *) 0);
      return (1);
    }

    if (argc < 3 || (tmpx = atoi (argv[2])) <= 0) {
      log_printf ("invalid block size.\n", (char *) 0);
      return (1);
    }
    dddb_setbsiz (tmpx);
    log_printf ("block size ", argv[2], ".\n", (char *) 0);
    return (0);
  }

  /* configure database hash directory */
  if (!strcmp (argv[1], "dbfile")) {
    char *xp;

    if (dddb_initted ()) {
      log_printf ("database is already active.\n", (char *) 0);
      return (1);
    }
    if (argc < 3) {
      log_printf ("must provide database name.\n", (char *) 0);
      return (1);
    }
    dddb_setfile (argv[2]);
    log_printf ("database is now ", argv[2], "\n", (char *) 0);
    return (0);
  }

  log_printf ("_dbconfig: I don't understand ", argv[1], "\n", (char *) 0);
  return (0);
}
#endif // DB_DBMFILE
