/*
    Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

/*
this is an example of how to handle updating rwho information from
within a MUD, specifically UnterMUD.

first off, we assume the client layer has already been initialized (a
safe bet) and then we send a 'mud-is-still-up' message, and then walk
our list of who is on, and send the information about each player as
a "plyer-is-logged-in" message
*/

/* configure all options BEFORE including system stuff. */
#include    "config.h"
#include    "mud.h"
#include "rwho.h"

extern void rwhocli_pingalive ();

void update_rwho (void)
{
  char *xx;
  time_t tv;

  io_rstnxtwho ();
  rwhocli_pingalive ();
  while ((xx = io_nxtwho (&tv)) != (char *) 0)
    rwhocli_userlogin (xx, ut_name (xx), tv);
}
