/*
    Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

#include    "config.h"
#include    "mud.h"

static struct errtbl {
  int num;
  char *msg;
} errs[] = {
  {
  UERR_NONE, "no error"}, {
  UERR_FATAL, "internal/system error"}, {
  UERR_USER, "user specified error"}, {
  UERR_TYPE, "type mismatch"}, {
  UERR_ZDIV, "division by zero"}, {
  UERR_BADOID, "illegal/nonexistent object ID"}, {
  UERR_BADLST, "bad list"}, {
  UERR_ILLASGN, "illegal assignment"}, {
  UERR_NOATTR, "no such attribute"}, {
  UERR_NOFUNC, "no such function"}, {
  UERR_SYNTAX, "syntax error"}, {
  UERR_PERM, "permission denied"}, {
  UERR_ARGCNT, "too many/few parameters"}, {
  UERR_BADPARM, "illegal parameters"}, {
  UERR_NOMATCH, "no matching object"}, {
  -1, 0}
};



char *mud_errtxt (int no)
{
  struct errtbl *erp;

  for (erp = errs; erp->msg != (char *) 0; erp++)
    if (erp->num == no)
      return (erp->msg);
  return ("unknown error");
}
